/*

-------------------------------------------------------------------------------
ARITMETIKA VYSOKYCH CISEL

Zadani:

Naprogramujte program, ktery precte na vstupu dve cisla a podle zadane
hodnoty (symbolu) s nimi provede prislusnou operaci. Cisla nejsou omezena
rozsahem hodnoty integer, ani long integer ani long long integer. Omezena
je pouze jejich delka. Klasicky muzete pocitat v programech napr. s hodnotou
2^31, vy naprogramujte program, ktery bude umet pocitat s cisly, ktera
maji napr. 2^31 cifer.

Cisla budete ukladat do pole, ktere budete dynamicky alokovat pri behu
programu. Kdyz program spoustite, nevite, jak dlouhe cislo uzivatel zada,
budete se tedy rozhodovat az za behu programu. K tomu pouzijete funkce
malloc a realloc, probrane na prednasce.

Pro nase ucely postaci, kdyz vyresite pouze operace scitani a nasobeni.
Pro scitani vytvorte funkci soucet, ktera bude mit zhruba tento fun. prototyp:
void soucet(char *pom, char *prvni, char *druhy, int delka_a, int delka_b);
tedy secte cislo z prvni a cislo z druhy a ulozi vysledek do pom.
Zde delka_a je delka prvniho pole a delka_b druheho pole). Parametry muzete
pridavat, nemelo by jich byt ale mene. Pri implementaci soucinu ji budete
pouzivat mnohokrat, vyplati se proto napsat si ji jako samostatnou funkci.

Vypocitejte hodnotu zadaneho vyrazu, vytisknete ji.

Pozadavky:

Vas program nazvete calc.c a ulozte jej do adresare...

Vstupni data budou ve tvaru:
prvni_cislo*druhe_cislo=
nebo pro soucet
prvni_cislo+druhe_cislo=

po zadani rovnitka program spocte a vypise vysledek a skonci s navratovou
hodnotou 0.

Pripadne chybne vstupy osetrete, mely by se take projevit na navratove
hodnote programu.
-------------------------------------------------------------------------------

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#define MAX(a,b) (a<b?b:a)

void soucet(char *temp, char *prvni, char *druhy, int a_in, int b_in, char s);

int main() {

  int mez = 1;
  char *prvni = (char *)malloc(10*sizeof(char));
  char *druhy = (char *)malloc(10*sizeof(char));
  char *temp = (char *)malloc(10*sizeof(char));
  int a,b,max,i,j,sum,carry,k;
  div_t pomoc;
  char c, op;

  a = 0;
  printf("Aritmetika vysokych cisel\n");
  c = (char)getchar();
  while (c!='*' && c!='+') {
    if (isdigit((int)c)) {
      prvni[a]=c-48;
      a++;
      if (a>=mez*10) {
        mez++;
	prvni = (char *)realloc(prvni, 10*mez*sizeof(char));
      }
    }
    c = (char)getchar();
  }
  op = c;

  b = 0; mez = 1;
  c = (char)getchar();
  while (c!='=') {
    if (isdigit((int)c)) { 
      druhy[b]=c-48;
      b++;
      if (b>=mez*10) {
        mez++;
        druhy = (char *)realloc(druhy, 10*mez*sizeof(char));
      }
    }
    c = (char)getchar();
  };
  getchar();
 
  if (op=='+') {
    temp = (char *)realloc(temp, (MAX(a,b)+1)*sizeof(char)); 
    max = MAX(a,b)+1;
    for(i=0;i<max;i++) {temp[i]=0; }
    soucet(temp, prvni, druhy, a, b, 0);
  }
  if (op=='*') {
    max = a+b; 
    temp = (char *)realloc(temp, max*sizeof(char));
    for(i=0;i<max;i++) temp[i]=0;
    char *multip = (char *)malloc(sizeof(char));
    b--; a--; carry = 0; j = 0; k = 0;
    while(b-j>=0) {
      i = 0;
      sum = a+2+j;
      multip = (char *)realloc(multip, sizeof(char)*sum);
      for(i=0;i<sum;i++) multip[i]=0; i=0;
      while(a-i>=0) {
        for(k=0;k<=j;k++) { multip[sum-k]=0; }
        if (druhy[b-j]*prvni[a-i]+carry>9) {
          pomoc = div((druhy[b-j]*prvni[a-i]+carry),10);
	  multip[sum-i-j-1] = pomoc.rem;
          carry = pomoc.quot;
        }
        else {
          multip[sum-i-j-1] = druhy[b-j]*prvni[a-i]+carry;
          carry = 0;
        }
        i++;
      }
      multip[0] = carry==0?0:carry;
      carry = 0;
      soucet(temp, temp, multip, max, sum, 1);
      j++;
    }
  }
    
  a = b = i = 0;
  while(temp[i]==0 && i<max-1) i++;
  while(i<max) {
    printf("%d", temp[i]);
    i++;a++;b++;
  }
  printf("\n");

  return 0;
}

void soucet(char *temp, char *prvni, char *druhy, int a_in, int b_in, char s) {

  int i_in, carry_in, max_in;
  max_in = MAX(a_in,b_in);
  if (s) max_in--;
  a_in--;
  b_in--; i_in=0; carry_in=0;
  while(a_in-i_in>=0 && b_in-i_in>=0) {
    if (prvni[a_in-i_in]+druhy[b_in-i_in]+carry_in>9) {
      temp[max_in-i_in] = prvni[a_in-i_in] + druhy[b_in-i_in] +carry_in - 10;
      carry_in = 1;
    }
    else {
      temp[max_in-i_in] = prvni[a_in-i_in] + druhy[b_in-i_in] + carry_in;
      carry_in = 0;
    }
    i_in++; 
  }
 
  if (b_in>a_in) {
    while(b_in-i_in>=0) {
      temp[max_in-i_in] = druhy[b_in-i_in] + carry_in;
      carry_in = 0;
      i_in++;
    }
  }
  if (a_in>b_in) {
    while(a_in-i_in>=0) {
      temp[max_in-i_in] = prvni[a_in-i_in] + carry_in;
      carry_in = 0;
      i_in++;
    }
  }
  temp[0] += carry_in;
}
